#!/usr/bin/perl -w

use Tk;
use strict;

my $FileName = $ARGV[0];
my $Override = $ARGV[1];
my $ExcludePrevious = $ARGV[2];

my $WindowBackGround = $ENV{ALU_FMBG_COLOR};
$WindowBackGround = "grey80" if not $WindowBackGround;
my $WindowForeGround = $ENV{ALU_FMFG_COLOR};
$WindowForeGround = "black" if not $WindowForeGround;
my $DisplayBackGround = $ENV{ALU_BG_COLOR};
$DisplayBackGround = "grey20" if not $DisplayBackGround;
my $DisplayForeGround = $ENV{ALU_FG_COLOR};
$DisplayForeGround = "white" if not $DisplayForeGround;

my $Window = MainWindow -> new;

$Window -> title("Monitor of file $FileName");
$Window -> geometry("+0+0");
$Window -> withdraw;
if ($Override)
  { $Window -> overrideredirect(1); }


$Window -> protocol("WM_DELETE_WINDOW",
                          sub { $Window -> withdraw(); });

$Window ->  configure(-background => $WindowBackGround,
                      -foreground => $WindowForeGround);


$Window -> Button(-text => "Dismiss",
                  -relief => 'groove', -borderwidth => 2,
                  -background => $DisplayBackGround,
                  -foreground => $DisplayForeGround,
                  -command => sub { $Window -> withdraw(); }
                 ) -> pack(-side => 'bottom')
           -> focus;


if ($Override)
{
  $Window -> Label(-text => "Monitor of file $FileName",
                   -background => $WindowBackGround,
                   -foreground => $WindowForeGround)
             -> pack(-side => "top");
}

my $Display = $Window -> Scrolled("Text", -scrollbars => 'sw',
                                  -background => $DisplayBackGround,
                                  -foreground => $DisplayForeGround);

$Display -> Subwidget("xscrollbar")
         -> configure(-background => $WindowBackGround);

$Display -> Subwidget("yscrollbar")
         -> configure(-background => $WindowBackGround);

$Display -> configure(-wrap => "none",
                      -state => 'normal');
$Display -> pack(-side => 'top', -fill => 'both', "-expand" => 1);



open FILE, $FileName || die "cannot open $FileName";
while (<FILE>)
 { $Display -> insert("end", $_) if not $ExcludePrevious; };

$Window -> repeat(1000,
                  sub {
                        while (<FILE>)
                        {
                          if (! $Window -> ismapped)
                          {
                            $Window -> deiconify();
                            $Display -> insert("end", "\n===============================================================================\n");
                          }
                          $Display -> insert("end", $_);
                          $Display -> see("end");
                          $Window -> update();
                          $Window -> raise();
                        }
                      });

MainLoop();

exit;
