divert(-1)
# AnotherLevelUp/fvwm2rc.decors.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999 and Red Hat Software, Inc

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.decors.m4,v 1.10 1999/04/05 18:33:46 notting Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#

###########################################################################
# m4 defines for FVWM options
# Be careful w/ these-- m4 is case-sensitive

# FvwmAlias macro will ease the trouble-- you can use all lower case, 
# all uppercase, or *proper* mixed capitalization
# eg. StickyOnTop, stickyontop, or STICKYONTOP all work
# but StickyonTop will *not* work

define(`FvwmAlias',`
define(`$1',`$2')
define(upcase(`$1'),`$2')
define(downcase(`$1'),`$2')
')

FvwmAlias(StickyOnTop,`StaysOnTop,Sticky')
FvwmAlias(WinCircSkip,`WindowListSkip,CirculateSkip')
FvwmAlias(MinimalDecoration,`NoTitle,NoHandles,BorderWidth 1')
FvwmAlias(NoDecoration,`NoTitle,NoHandles,BorderWidth 0')
FvwmAlias(`FullMaximize',`Maximize 100 97')
FvwmAlias(`TallMaximize',`Maximize 0 97')
FvwmAlias(`WideMaximize',`Maximize 100 0')
FvwmAlias(`WindowListIcons',`WindowList 1 -1')

define(`PctOfScreenInPixelsX',`eval( ($1 * WIDTH) / 100)')
define(`PctOfScreenInPixelsY',`eval( ($1 * HEIGHT) / 100)')

define(`PctOfScreenInPixels',`PctOfScreenInPixelsX($1) PctOfScreenInPixelsY($2)')
define(`PointOfScreen', `PctOfScreenInPixelsX($1)p PctOfScreenInPixelsY($2)p')

define(`GeometryPctOfScreen',`PctOfScreenInPixelsX($1)xPctOfScreenInPixelsY($2)')


###########################################################################
#
# Now set internal macros based on configured parameters
#

ifelse(SCREEN_SIZE,`Small',
`define(`FONT_SIZE',SMALL_SCREEN_BASIC_FONT_SIZE)',
`define(`FONT_SIZE',BASIC_FONT_SIZE)')

define(`FONT_SIZE_X_2',eval(FONT_SIZE * 2))

# This makes the assumption that our binary name is the basename of the directory
# in which the modules are stored

ifdef(`RH5', `
ifdef(`FVWM_BIN_NAME',`',
`define(`FVWM_BIN_NAME',m4_basename(FVWMDIR))')
', `
ifdef(`FVWM_BIN_NAME',`',
`define(`FVWM_BIN_NAME',m4_basename(FVWM_MODULEDIR))')
')

# Check if Fvwm95 is sourcing this file
ifelse(FVWM_BIN_NAME,fvwm95,`define(`FVWM95')',
 FVWM_BIN_NAME,fvwm95-2,`define(`FVWM95')')

define(`ICONIFY_LABEL',`Hide')
ifdef(`USE_ICONS',`define(`ICONIFY_LABEL',`Iconify')')

# StartProgramIn{ColorXterm,Xterm,Rxvt}(<prg-name-and-options>,<title>,
#                    <x-class-for-resources>
define(`StartProgramInXterm',`IfProgramExistsOrError(ProgramName($1),`xterm -T $2 -n $2 ifelse($3,,,`-name $3') -e $1')')
define(`StartProgramInColorXterm',`IfProgramExistsOrError(ProgramName($1),XTERM `-T $2 -n $2 ifelse($3,,,`-name $3') -e $1 ')')
define(`StartProgramInRxvt',`IfProgramExistsOrError(ProgramName($1),RXVT `-T $2 -n $2 ifelse($3,,,`-name $3') -e $1 ')')

define(`StartNonInteractiveProgramInRxvt',`IfProgramExistsOrError(ProgramName($1),RXVT `-T $2\ --\ Use\ Meta-PgUp/Dn\ to\ Scroll -n $2 ifelse($3,,,`-name $3') -e sh -c "$1 && read waitforreturn"')')

#These are not used now for small button bars (panels), only big ones
define(`BUTTON_BAR_ROWS_OR_COLS',`Rows')
ifdef(`USE_VERTICAL_BUTTON_BARS',`define(`BUTTON_BAR_ROWS_OR_COLS',`Columns')')

# User might not want mini-icons
#define(`__MiniIcon',mini-$1.xpm)
#RH6.0 fvwm2-icons has some mini-icons in mini.name.xpm format! :-(
#Anyway, I think where there are mini.$1.xpm file, they are nicer, so
define(`__MiniIcon', `syscmd(/bin/ls /usr/share/icons/mini/mini.$1.xpm >/dev/null 2>&1)ifelse(sysval,0,/usr/share/icons/mini/mini.$1.xpm,mini-$1.xpm)')
define(`RegularIcon',$1.xpm)

divert

#XTermOtherHost <Host> <Title>
#Starts an xterm running a telnet/rlogin to another host (the xterm runs locally)
AddToFunc XTermOtherHost
+ "I" exec XTERM -name remotexterm -T $0 -n $0 -e RLOGIN_OR_TELNET $1

###########################################################################
#
# Set misc. interaction preferences
#
ClickTime	CLICK_MS
TitleStyle	TITLE_STYLE
ColorMapFocus	COLOR_MAP_FOCUS
OpaqueMoveSize	OPAQUE_MOVE_SIZE
EdgeResistance	EDGE_SCROLL_RESISTANCE EDGE_MOVE_RESISTANCE
EdgeScroll	100 100

# DECORS: Now we are ready to include the choosen decoration...
changecom(%%%)
# `WM_STYLE     '=WM_STYLE
# `WM_STYLE_PATH'=ANOTHERLEVEL/decors/WM_STYLE
changecom(#)

sinclude(ANOTHERLEVEL/decors/WM_STYLE)

###########################################################################
#
# Fonts - one for window titles, another for icons, and another for the menus
#
WindowFont	BASIC_FONT*bold-r*FONT_SIZE*
IconFont	ICON_FONT

# Change comment in case multiple colours starting with #
changecom(%%%)
ifdef(`RH5', `
MenuStyle	MENUFORE_COLOR MENUBACK_COLOR MENUSHADE_COLOR BASIC_FONT*medium-r*FONT_SIZE* mwm
', `

# Make move/resize feedback window appear in middle of screen
Emulate mwm
# Set colours for move/resize feedback window
DefaultColors MENUFORE_COLOR MENUBACK_COLOR

MenuStyle * mwm
ifelse(MenuAnimation, `Yes', `
MenuStyle * Animation
')
MenuStyle * Font BASIC_FONT*medium-r*FONT_SIZE*

MenuStyle * Greyed MENUSHADE_COLOR

ifelse(MenuBackgroundKind, `Shiny', `
MenuStyle * Foreground MENUSHINE_FORE_COLOR
MenuStyle * MenuFace HGradient 128 2 MENUBACK_COLOR 30 MENUSHINE_BACK_COLOR 70 MENUBACK_COLOR
',`
MenuStyle * Foreground MENUFORE_COLOR
MenuStyle * Background MENUBACK_COLOR
')
')

changecom(#)

###########################################################################
#
# Forms - define fonts and colours
#

define(`FORM_FONT', `MEDIUM_FONT')
define(`FORM_BUTTONFONT', `BASIC_FONT*FONT_STYLE*FONT_SIZE*')
define(`FORM_INPUTFONT', `MEDIUM_FONT')
define(`FORM_FORE', `MENUFORE_COLOR')
define(`FORM_BACK', `MENUBACK_COLOR')
changecom(%%%)
ifelse(WINBACK_COLOR, MENUBACK_COLOR, `
define(`FORM_ITEMFORE', `FG_COLOR')
define(`FORM_ITEMBACK', `BG_COLOR')
',`
define(`FORM_ITEMFORE', `WINFORE_COLOR')
define(`FORM_ITEMBACK', `WINBACK_COLOR')
')
changecom(#)

divert(-1)

ifdef(`MINI_ICONS',`define(`MiniTitleIcon',
`ifelse($1,`',`',`%__MiniIcon($1)%')')',
`define(MiniTitleIcon)')

define(`SetTitleIcon',`ifelse($2,`',`',`Style "$1" MiniIcon __MiniIcon($2)
')')

define(`SetCurrentMenu',`define(`CURRENT_ADD_TO_MENU',$1)')
SetCurrentMenu(`UndefinedLM')

# As of RH6.0, smart placement no longer works for button bars!
# Anyway, good to choose the place for them...
# Also see below - override of BUTTON_BAR_ROWS_OR_COLS to get good layout

define(`BUTTON_BAR_POS', 45)
define(`BUTTON_BAR_BUTTON_COUNT', 0)

define(`AddNewMenuAndButtonBar',`
ifdef(`PROVIDE_TEAROFF_BUTTON_BAR',`
define(`BUTTON_BAR_POS', eval(BUTTON_BAR_POS + (BUTTON_BAR_BUTTON_COUNT + BUTTON_BAR_COLUMNS - 1) / BUTTON_BAR_COLUMNS * 34 + 5))
Style "$1`'Buttons"	Sticky, WinCircSkip, NoDecoration
*$1`'ButtonsGeometry -0+BUTTON_BAR_POS
define(`BUTTON_BAR_BUTTON_COUNT', 0)
*$1`'Buttons`'Columns BUTTON_BAR_COLUMNS
*$1`'ButtonsFore WINFORE_COLOR
*$1`'ButtonsBack WINBACK_COLOR
AddToMenu $1 ifelse($2, `', "$1 Button Panel`'MiniTitleIcon(modules)", $2) Function ButtonBar$1
AddToFunc ButtonBar$1
+ "I" Popup Toggle`'$1`'Buttons_Button
')
ifdef(`PROVIDE_TEAROFF_BIG_BUTTON_BAR',`
Style "$1`'BigButtons"     Sticky, WinCircSkip, NoDecoration
*$1`'BigButtons`'BUTTON_BAR_ROWS_OR_COLS 2
*$1`'BigButtonsFore WINFORE_COLOR
*$1`'BigButtonsBack WINBACK_COLOR
*$1`'BigButtonsPadding 0 0
*$1`'BigButtonsFont ifdef(`BUTTON_BARS_FONT',`BUTTON_BARS_FONT',`None')
AddToMenu $1 "$1 Big Button Bar`'MiniTitleIcon(modules)" Module FvwmButtons $1`'BigButtons
')
#At least give it a title
ifdef(`PROVIDE_TEAROFF_BIG_BUTTON_BAR',`',ifdef(`PROVIDE_TEAROFF_BUTTON_BAR',`',`
AddToMenu $1 $1 Title'))
AddToMenu $1
+ "" Nop
SetCurrentMenu($1)
')

# DefineProgram <menu-app-type> <program-label> <miniicon> <bigicon> <command-name>
# (only gets added if <command-name> is an executable program on the
#  current system)
# Be cautious of using quotes in command-name, or elsewhere, as single
# quote can mess up m4, and double quotes can mess up the button bar
# as they interact with the quotes around FvwmButton's Action keyword parameter
# Consider, instead, backslash-escaping all spaces in an argument.
# (See StartNonInteractiveProgramInRxvt definition, below.

changequote([[,]])
define([[Quoted]],[['$1']])
changequote(`,')

# Since we don't want the button's labels to have &'s, we need a macro
# to remove them.
define(`NoAmpersands',`translit(`$*',`&',`')')

define(`DefineProgram',`IfProgramExists(ProgramName($5),`
#FIX: not quite right
#ifelse(eval($# != 5),`0',errprint(`Not 5 args to DefineProgram for $5
#'))dnl
SetTitleIcon(patsubst($5,[ ].*$,),$3)dnl
AddToMenu $1 "$2`'MiniTitleIcon($3)" Exec $5
ifdef(`PROVIDE_TEAROFF_BUTTON_BAR',`
ifelse($3,,,
`#This must be in quotes so only gets expanded in false case of ifelse
define(`BUTTON_BAR_BUTTON_COUNT', eval(BUTTON_BAR_BUTTON_COUNT + 1))
AddToMenu $1`'BUTTON_BAR_BUTTON_COUNT "*mini-down.xpm*" Title
+ "NoAmpersands($2) *__MiniIcon($3)*" Exec $5
*$1`'Buttons(Icon __MiniIcon($3), Action "`Popup' $1`'BUTTON_BAR_BUTTON_COUNT")
')
')
ifdef(`PROVIDE_TEAROFF_BIG_BUTTON_BAR',`
ifelse($4,,*$1`'BigButtons(Title "NoAmpersands($2)", Action Quoted(`Exec "ProgramName($5)" $5')),
`*$1`'BigButtons(Icon RegularIcon($4), Action Quoted(`Exec "ProgramName($5)" $5'))')
')
ifdef(`USE_ICONS',`
ifelse($4,,,`Style "ProgramName($5)" Icon RegularIcon($4)')')
')')

# MenuAndButtonEntry <menu>  <label> <miniicon> <bigicon> <command-name>
#                       1        2         3       4          5
# Be cautious of using quotes in command-name, or elsewhere, as single
# quote can mess up m4, and double quotes can mess up the button bar
# as they interact with the quotes around FvwmButton's Action keyword parameter
define(`MenuAndButtonEntry',`
AddToMenu $1 "$2`'MiniTitleIcon($3)" $5
ifdef(`PROVIDE_TEAROFF_BUTTON_BAR',`
ifelse($3,,,
`#This must be in quotes so only gets expanded in false case of ifelse
define(`BUTTON_BAR_BUTTON_COUNT', eval(BUTTON_BAR_BUTTON_COUNT + 1))
ifelse(regexp($5,`Popup Toggle'), `0',
*$1`'Buttons(Icon __MiniIcon($3), Action "$5_Button"),
ifelse(regexp($5,`Popup'),`0',
*$1`'Buttons(Icon __MiniIcon($3), Action "$5"),
AddToMenu $1`'BUTTON_BAR_BUTTON_COUNT "*mini-down.xpm*" Title
+ "NoAmpersands($2) *__MiniIcon($3)*" $5
*$1`'Buttons(Icon __MiniIcon($3), Action "`Popup' $1`'BUTTON_BAR_BUTTON_COUNT")
))')
')
ifdef(`PROVIDE_TEAROFF_BIG_BUTTON_BAR',`
ifelse($4,,*$1`'BigButtons(Title "NoAmpersands($2)", Action "$5"),`
*$1`'BigButtons(Icon RegularIcon($4), Action "$5")')
')')

# MenuSeparator <menu>
define(`MenuSeparator',
`AddToMenu $1
+ "" Nop
')

define(`DefineProgramLM',`DefineProgram(CURRENT_ADD_TO_MENU,$@)')
define(`MenuAndButtonEntryLM',`MenuAndButtonEntry(CURRENT_ADD_TO_MENU,$@)')
define(`MenuSeparatorLM',`MenuSeparator(CURRENT_ADD_TO_MENU,$@)')

# Note: Use SetCurrentMenu(<menu name>) to make the *LM commands use <menu name>
# as the menu to add to

divert

# This part changed to allow for non existence of /usr/X11R6/bin/RunWM.*
# and also only offer the other AnotherLevelUp decor from the current one

AddToMenu WindowManagers
+ ""	Title
IfElseProgramExists(`/usr/X11R6/bin/RunWM', `
ifelse(WM_STYLE, `FVWM95', `',  `+  "FVWM 95"		ReallyRestartWm /usr/X11R6/bin/RunWM.Fvwm95')
ifelse(WM_STYLE, `MWM', `',     `+  "Lesstif WM"	ReallyRestartWm /usr/X11R6/bin/RunWM.MWM')
IfProgramExists(`afterstep',	`+  "AfterStep"		ReallyRestartWm /usr/X11R6/bin/RunWM.AfterStep')
IfProgramExists(`wmaker',	`+  "WindowMaker"	ReallyRestartWm /usr/X11R6/bin/RunWM.WindowMaker')
', `
ifelse(WM_STYLE, `FVWM95', `',  `+  "FVWM 95"		Function RestartFvwm95')
ifelse(WM_STYLE, `MWM', `',     `+  "Lesstif WM"	Function RestartMwm')

AddToFunc RestartFvwm95
+ "I" Exec echo Fvwm95 > USER_WM_STYLE
+ "I" Function ReallyRestart

AddToFunc RestartMwm
+ "I" Exec echo Mwm > USER_WM_STYLE
+ "I" Function ReallyRestart
')

TraceForErrors(`finished decorating...')
