divert(-1)
# AnotherLevelUp/fvwm2rc.menus.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999, 2000, 2001 and Red Hat Software, Inc

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.menus.m4,v 1.11 1999/04/05 18:31:57 notting Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

###########################################################################
#
# Now create the menus
#

# This builds the favourites menu and the wmconfig programs menu
TraceForErrors(`Favourites menu...')
readFile(`fvwm2rc.favourites')


TraceForErrors(`Basic start menu...')

define(`IfHostsDefined', `
ifdef(`USER_HOST_LIST', `$1', ifdef(`AUTO_HOST_MENU', `$1'))
')

# The following is defined as a function, so that the fixed positioning of the
# random settings sub-menu works. For some reason it does not work if the
# StoredPreferences menu is popped up directly from the StartMenu.

AddToFunc PopupStoredPreferences
+ "I" Popup StoredPreferences

# Start the main menu
AddToMenu StartMenu
#+ "A.L.U. (ALU_RELEASE) ..." Menu StoredPreferences
+ "A.L.U. (ALU_RELEASE) ..." Function PopupStoredPreferences
AddNewMenuAndButtonBar(StartMenu, "Toggle Button Panel MiniTitleIcon(modules)")

# The main menu is here as MenuAndButtonEntryLM entries
MenuAndButtonEntryLM(New &Shell,sh1,,Exec  XTERM)
ifdef(`XEDITOR', `MenuAndButtonEntryLM(New &Editor,edit,,Exec XEDITOR)')
MenuAndButtonEntryLM(New &Netscape,nscape,,Exec  NETSCAPE_DEFAULT)
IfProgramExists(`gmc', `
MenuAndButtonEntryLM(&Gnome Browser,filemgr,,Popup ToggleGMC)
')

ifdef(`HostSpecificStartMenu', HostSpecificStartMenu)

AddToMenu StartMenu
+ "" Nop

MenuAndButtonEntryLM(&Favourites...,run,,Function CreateAndPopupFavouritesMenu)

ifdef(`USER_MENU',
`AddToMenu UserMenu USER_MENU
MenuAndButtonEntryLM(User &menu,run,,Popup UserMenu)')

AddToMenu StartMenu
+ "" Nop

MenuAndButtonEntryLM(&Help tool,question,,Exec helptool)
MenuAndButtonEntryLM(Calendar / &Diary,clipboard,,Exec  XCAL)
changecom
MenuAndButtonEntryLM(&Calculator,calc,,Exec xcalc -bg "FMBG_COLOR" -fg "FMFG_COLOR" -stipple)
changecom(#)
IfProgramExists(`ddd', `
MenuAndButtonEntryLM(D&ebugger (ddd),roach,,Exec ddd)
')
AddToMenu StartMenu
+ "" Nop
MenuAndButtonEntryLM(&Other Programs,penguin,penguin,Popup ROOT_MENU)


# seek for big applications already on disk...
readFile(`fvwm2rc.apps')

AddToMenu StartMenu
+ "" Nop

ifdef(`WANT_NETWORK_CONNECTIONS', `MenuAndButtonEntryLM(Net&work Connections...,telnet,,PipeRead "ANOTHERLEVEL/bin/network-connections NETWORK_CONNECTIONS_HOST")')
IfHostsDefined(`MenuAndButtonEntryLM(H&osts,windows,,Popup Hosts)')
MenuAndButtonEntryLM(&Preferences,prefs,,Popup Preferences)
MenuAndButtonEntryLM(System &Utilities,connect,,Popup SystemUtilities)
MenuAndButtonEntryLM(&Window Operations,windows,,Popup Window-Ops)

AddToMenu StartMenu
+ "" Nop

# fvwm2rc.xlock is configurable, so can be used to make
# moving background menu too
define(`XLOCKFORMNAME', `XLock')
define(`XLOCKLOCKSCREEN')
undefine(`XLOCKBACKGROUND')
readFile(`forms_Xlock')
ifdef(`XLockScreenUserChoice', `
define(`XLockUserChoice', XLockScreenUserChoice)
')
readFile(`fvwm2rc.xlock')

AddToMenu StartMenu
MenuAndButtonEntryLM(&Lock Screen,lock,,FvwmForm XLOCKFORMNAME`1')

AddToMenu StartMenu
+ "" Nop

MenuAndButtonEntryLM(A&bout Fvwm,exclam,,FvwmForm About)

AddToMenu StartMenu
+ "" Nop

MenuAndButtonEntryLM(E&xit Fvwm,stop,,Popup Quit-Verify)

AddToMenu "Quit-Verify" "Really Quit Fvwm?" Title
+ "&No, Don't Quit MiniTitleIcon(cross)" 	Nop
+ "&Yes, Really Quit MiniTitleIcon(exclam)"	ifdef(`NO_VERIFY_QUIT',`Quit',`FvwmForm LogoutVerify')
+ ""						Nop
+ "&Other Options"                              Popup QuitOthers

AddToMenu QuitOthers "More restart/quit options" Title
+ "&Restart MiniTitleIcon(turn)"		Function ReallyRestart
+ "Restart &Programs MiniTitleIcon(turn)"	StartupFunction
+ ""						Nop
+ "&Switch To... MiniTitleIcon(windows)"	Popup WindowManagers
ifdef(`WANT_SHUTDOWN_OPTIONS', `
IfProgramExists(`/usr/bin/shutdown', `
+ ""						Nop
+ "Shutdown &Halt MiniTitleIcon(stop)"		Exec /usr/bin/shutdown -h now
+ "Shutdown Re&boot MiniTitleIcon(turn)"	Exec /usr/bin/shutdown -r now
')
')

readFile(`fvwm2rc.menus.preferences')
readFile(`fvwm2rc.menus.systemutilities')
readFile(`fvwm2rc.menus.windowoperations')

TraceForErrors(`Including_fvwm_hostmenus...')
# .fvwm2rc.hostmenus sets up the various menus for working w/ hosts
readFile(`fvwm2rc.hostmenus')
