divert(-1)
# AnotherLevelUp/fvwm2rc.xlock.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999 and Red Hat Software, Inc

# This file is now very different in structure to that of AnotherLevel

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.xlock.m4,v 1.2 1999/09/23 20:02:58 pbrown Exp $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

TraceForErrors(`Xlock form 'XLOCKFORMNAME`...')

# Enable nested forms
define(`XLOCK', XLOCKFORMNAME`1')

define(`AddXLockOption',`*XLOCK`'Choice	Option $1 off "capitalize($1)"')

*XLOCK`'WarpPointer

# Enable nested forms
define(`XLOCK_PRELUDE', `
*XLOCK`'Font		FORM_FONT

# Note: ButtonFont for this form is a fixed size font; so buttons line up
# nicely. Obvious choice is InputFont
*XLOCK`'ButtonFont	FORM_INPUTFONT

*XLOCK`'InputFont	FORM_INPUTFONT
*XLOCK`'Fore		FORM_FORE
*XLOCK`'Back		FORM_BACK
*XLOCK`'ItemFore	FORM_ITEMFORE
*XLOCK`'ItemBack	FORM_ITEMBACK

*XLOCK`'Line 		center
*XLOCK`'Text 		"Available Xlock modes"
*XLOCK`'Selection		Option single
*XLOCK`'Line 		expand
')


# Enable nested forms
define(`XLOCK_USERCHOICE', `
# We add the random thing separately, to be sure that we have at least one
# selected option
*XLOCK`'Line    left
ifdef(`XLockUserChoice', `
*XLOCK`'Choice Option XLockUserChoice on "capitalize(XLockUserChoice) (Current saved choice)          "
',`
*XLOCK`'Choice Option random on "Random          "
')
')

define(`XLOCK_CONCLUDE', `

# Optional
ifdef(`XLOCKLOCKSCREEN',`
changecom(%%%)
*XLOCK`'Button	quit "Lock Screen"
ifdef(`RH5', `
*XLOCK`'Command	Exec xlock -nice NICELEVEL -mode $(Option) -timeelapsed -bg "BG_COLOR" -fg "FG_COLOR" -enablesaver -mousemotion -timeout 5
', `
*XLOCK`'Command	Exec xlock -nice NICELEVEL -erasemode no_fade -mode $(Option) -timeelapsed -bg "BG_COLOR" -fg "FG_COLOR" -enablesaver -mousemotion -timeout 5
')
*XLOCK`'Command	Exec test "$(Option)" != "XLockUserChoice" && `echo "define(\`XLockUserChoice', \`$(Option)')" > 'USER_PREFS_DIR`/forms_Xlock'
changecom(#)
')

# Optional
ifdef(`XLOCKBACKGROUND',`
*XLOCK`'Button	quit "Background"
*XLOCK`'Command	Exec ANOTHERLEVEL/bin/kill-all-proc xlock; "exec" xlock -nice NICELEVEL -mode $(Option) -nolock -inroot -enablesaver
changecom(%%%)
*XLOCK`'Command  Exec ANOTHERLEVEL/bin/save-background-preferences "Moving" "BG_COLOR" "FM_MODE" "BG_BITMAP" $(Option)
changecom(`#')
')

*XLOCK`'Button   continue "Try"
*XLOCK`'Command Exec "exec" xlock -nice NICELEVEL -mode $(Option) -nolock -enablesaver -mousemotion

# Optional
ifdef(`XLOCKBACKGROUND',`
*XLOCK`'Button	quit "Cancel - Select static"
*XLOCK`'Command	FvwmScript ScreenSetup
')

*XLOCK`'Button	quit "Cancel" ^[
*XLockCommand	Nop
')

esyscmd(`xlock -help 2>&1 \
         | awk "BEGIN{item = 0; thispage = 1; thispagecount = 0} \
		/^$/ {next} \
		/one of:/ {ok=1; next} \
		/^[ \t]*[a-z]/ && ok==1 \
		{ \
                  if (thispagecount == 0)  { print \"XLOCK_PRELUDE\" }; \
		  if (item == 0) { print \"*XLOCK\`'Line	expand\" }; \
		  printf(\"AddXLockOption(%-15s,%s)\\n\", \$1, \$1) ; \
		  item = (item+1)%5 ; \
                  thispagecount = (thispagecount+1) ; \
                  if (thispagecount == 50) \
                    { print \"XLOCK_USERCHOICE\"; \
                      thispagecount = 0 ; \
                      thispage = (thispage+1); \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Button  quit \\\"Next Page\\\"\"; \
                      print \"*XLOCK\`'Command  FvwmForm XLOCKFORMNAME\`'\"thispage; \
                      print \"XLOCK_CONCLUDE\"; \
                      print \"define\(\`XLOCK', XLOCKFORMNAME\`'\"thispage\")\" }; \
		} \
                END { print \"XLOCK_USERCHOICE\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Button  quit \\\"First Page\\\"\"; \
                      print \"*XLOCK\`'Command  FvwmForm XLOCKFORMNAME\`1'\"; \
                      print \"XLOCK_CONCLUDE\" }"')
